Index: /Interface_Web/trunk/pspaWT/cmt/requirements
===================================================================
--- /Interface_Web/trunk/pspaWT/cmt/requirements	(revision 492)
+++ /Interface_Web/trunk/pspaWT/cmt/requirements	(revision 493)
@@ -39,5 +39,4 @@
  ../sources/controler/src/softwareGenerator.cc \
  ../sources/controler/src/softwareUsersprogram.cc \
- ../sources/controler/src/sectionToExecute.cc \
  ../sources/controler/src/softwareTest.cc \
  ../sources/controler/src/softwareMadx.cc \
@@ -45,4 +44,6 @@
  ../sources/controler/src/sectorParameters.cc \
  ../sources/controler/src/sector.cc \
+ ../sources/controler/src/expandedMachine.cc \
+ ../sources/controler/src/computingBlock.cc \
  ../sources/userInterface/src/GWt_elementCell.cc \
  ../sources/userInterface/src/GWt_elementRfgun.cc \
@@ -70,6 +71,7 @@
  ../sources/userInterface/src/GWt_serverFileSelector.cc \
  ../sources/userInterface/src/GWt_sector.cc \
+ ../sources/userInterface/src/GWt_machine.cc \
  ../sources/userInterface/src/GWt_accelerator.cc \
- ../sources/userInterface/src/GWt_sectionToExecute.cc
+ ../sources/userInterface/src/GWt_computingBlock.cc
  
 #######################################################################
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h	(revision 493)
@@ -16,5 +16,5 @@
 class dataManager;
 class sectionToExecute;
-
+class computingBlock;
 class abstractSoftware
 {
@@ -42,11 +42,17 @@
   //  void registerElement(nomdElements::typedElement nomdel,trivaluedBool b);
 
-  sectionToExecute* getSectionToExecute() {
-    return sectionToExecute_;
+  /* sectionToExecute* getSectionToExecute() { */
+  /*      return sectionToExecute_; */
+  /* } */
+
+  computingBlock* getComputingBlock() {
+       return compBlock_;;
   }
 
   public :
 
-  abstractSoftware(string, sectionToExecute*, dataManager* );
+  //  abstractSoftware(string, sectionToExecute*, dataManager* );
+  abstractSoftware(string, computingBlock*, dataManager* );
+
   ~abstractSoftware() {
     delete nameOfSoftware_;
@@ -74,6 +80,6 @@
   }
   private :
-  sectionToExecute* sectionToExecute_;
-  
+  //  sectionToExecute* sectionToExecute_;
+  computingBlock* compBlock_;
 };
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/computingBlock.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/computingBlock.h	(revision 493)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/computingBlock.h	(revision 493)
@@ -0,0 +1,115 @@
+#ifndef COMPUTINGBLOCK_SEEN
+#define COMPUTINGBLOCK_SEEN
+
+#include <iostream>
+#include <vector>
+
+#include "abstractElement.h"
+#include "abstractSoftware.h"
+#include "UAP/UAPNode.hpp"
+
+//#include "sectionToExecute.h"
+
+using namespace std;
+
+class expandedMachine;
+
+class computingBlock 
+{
+
+
+  friend class expandedMachine;
+
+
+
+ public:
+
+
+
+
+  inline  abstractSoftware* getSoftware() const {return software_;}
+
+  //  vector< abstractElement* > getElementsX(); 
+
+  inline expandedMachine* getMachine() {return machine_;}
+
+
+
+
+
+ inline unsigned getRankOfFirstElement() { return rankOfFirstElement_;}
+
+ inline unsigned getRankOfLastElement() {
+   return rankOfFirstElement_ + numberOfelements_ - 1;
+ }
+
+   abstractElement* getFirstElement();
+  abstractElement* getLastElement();
+ abstractElement* getElement(unsigned ind);
+
+  bool isEmpty() { 
+    if ( numberOfelements_ ) return false;
+    else return true;
+  }
+
+ inline  unsigned getNumberOfElements() { return numberOfelements_;}
+
+ private: 
+
+  computingBlock() {;}
+
+  computingBlock(unsigned premier, unsigned nombre, abstractSoftware* s,expandedMachine* mch);
+
+ computingBlock(expandedMachine* mac) : machine_(mac) {;}
+
+  void FileAMLOutput(UAPNode* root);
+  void FileAMLInput( UAPNode* entree);
+
+  inline void setSoftware(abstractSoftware* sw) {software_ = sw;}
+
+  inline bool removeFirstElement() {
+    rankOfFirstElement_++;
+    numberOfelements_--;
+    return checkCompatibilityWithMachine();
+  };
+
+  inline bool extendByTheEnd(unsigned nombre) {
+    numberOfelements_ += nombre;
+    return checkCompatibilityWithMachine();
+  };
+
+  inline bool suppressByTheEnd(unsigned nombre) {
+    numberOfelements_ -= nombre;
+    return checkCompatibilityWithMachine();
+  };
+
+  inline bool removeLastElement() {
+    numberOfelements_--;
+    return checkCompatibilityWithMachine();
+  }
+
+  bool checkCompatibilityWithMachine();
+
+  bool checkCoherence(string& diagnosticErrors, string& diagnosticWarnings);
+
+inline   void clearElements() { numberOfelements_ = 0; }
+ inline  void clearAll() { if ( software_ ) delete software_; software_=NULL;}
+ inline bool reinitialiseElements(unsigned first, unsigned number) {
+   rankOfFirstElement_ = first;
+   numberOfelements_ = number;
+   return checkCompatibilityWithMachine();   
+ }
+
+
+
+
+  abstractSoftware* software_;
+  unsigned rankOfFirstElement_;
+  unsigned numberOfelements_;
+  expandedMachine* machine_;
+};
+
+
+
+#endif
+
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h	(revision 493)
@@ -14,4 +14,6 @@
 #include "nomDeLogiciel.h"
 #include "sector.h"
+#include "expandedMachine.h"
+#include "computingBlock.h"
 
 #include "sectorParameters.h" //xx
@@ -24,5 +26,8 @@
  public:
   
-  dataManager() {;}
+ dataManager() :   
+  pspa_ (NULL),
+    currentMachine_(NULL)
+      {;}
   dataManager(PspaApplication*);
   virtual ~dataManager();
@@ -33,4 +38,22 @@
   particleBeam* getDiagnosticBeam_deprecated(string elementLabel);
 
+
+  //provisoire 
+  inline expandedMachine* getCurrentMachine() {return currentMachine_;}
+
+  inline expandedMachine* expandMachine() {
+    if ( !currentMachine_ ) currentMachine_ = new expandedMachine(this);
+    currentMachine_->fromSectors( sectors_, this );
+    return currentMachine_;
+  }
+
+  bool areDataCoherent() {
+    bool resultat = false;
+    if ( !currentMachine_ ) return false;
+    resultat = currentMachine_->areDataCoherent();
+    return resultat;
+  }
+
+
 /** Add a new sector
  */
@@ -39,5 +62,5 @@
   /** return all sectors
    */
-  inline std::vector <sector*> getSectors() {return jobList_;};
+  inline std::vector <sector*> getSectors() {return sectors_;};
   
   
@@ -60,9 +83,9 @@
   void writeToAMLFile(string fileName);
     
-  /** return the jobList size
+  /** return the sectors size
    */
-  inline unsigned long getJobListSize() const {
-    return jobList_.size();
-  }
+  //  inline unsigned long getSectorsSize() const {
+  //    return sectors_.size();
+  // }
   
   // si newBeam = true, on cree un nouveau diag
@@ -84,5 +107,11 @@
   };
 
-  
+  abstractElement* getElementInSectorsByLabel(string etiq);
+
+
+  void messageEcran(string niveau, string msg) const;
+
+
+
  private:
 
@@ -92,5 +121,7 @@
   vector<particleBeam> diagnosticBeam_;
   vector<unsigned> indexElementToIndexDiag_;
-  vector <sector*> jobList_;
+  //  vector <sector*> jobList_;
+  vector <sector*> sectors_;
+  expandedMachine* currentMachine_;
   void removeFile(string nameOfFile);
 };
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/expandedMachine.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/expandedMachine.h	(revision 493)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/expandedMachine.h	(revision 493)
@@ -0,0 +1,81 @@
+#ifndef EXPANDEDMACHINE_SEEN
+#define EXPANDEDMACHINE_SEEN
+
+#include <iostream>
+#include <vector>
+
+#include "abstractElement.h"
+#include "sector.h"
+#include "computingBlock.h"
+#include "UAP/UAPNode.hpp"
+
+using namespace std;
+
+class expandedMachine
+{
+
+
+
+  expandedMachine() {;}
+
+
+ public :
+
+
+ expandedMachine(dataManager* dtmg) : machineName_("dummy"), dataManager_(dtmg) {;}
+
+  ~expandedMachine() {
+    for ( unsigned k=0; k < computingBlocks_.size(); k++ ) delete computingBlocks_.at(k);
+  }
+
+  void setSoftware(std::string logiciel, computingBlock* cpblk);
+
+
+  void  fromSectors( const vector<sector*>& sect, dataManager* dtmg );
+  //  computingBlock* openBlock(dataManager* dmg); 
+
+
+
+   bool openNewLastBlock();
+
+
+  inline vector<abstractElement*>& getElements() {return elements_;}
+
+
+ inline vector<computingBlock*>& getComputingBlocks() {return computingBlocks_;}
+
+
+
+  abstractElement* getElementFromLabel(string lab);
+  int getElementRankFromLabel(string lab);
+  int getElementRankFromPointer(abstractElement* ptr);
+
+ void FileAMLOutput(UAPNode* root);
+ bool FileAMLInput( UAPNode* entree);
+
+ abstractSoftware* getSoftwarePointer(std::string logiciel, computingBlock* cpblk);
+
+ void setFirstElementOfBlock(computingBlock* bclk, int index);
+ void setLastElementOfBlock(computingBlock* bclk, int index);
+
+ abstractElement* getElementPointer( unsigned rang);
+ 
+ bool openNewBlockAfter(computingBlock* cpbl);
+
+
+ bool areDataCoherent();
+
+ bool eraseComputingBlock(computingBlock* );
+
+ inline unsigned numberOfElements() { return elements_.size(); }
+ private:
+
+ void clearComputingBlock(int a);
+
+  dataManager* dataManager_;
+  string machineName_;
+  vector<abstractElement*> elements_;
+  vector<computingBlock*> computingBlocks_;
+};
+
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h	(revision 493)
@@ -63,5 +63,5 @@
   }
 
-  trivaluedBool doAcceptElement(nomdElements::typedElement typdel); 
+  trivaluedBool doAcceptElement(nomdElements::typedElement typdel) const; 
 
 
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/sector.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/sector.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/sector.h	(revision 493)
@@ -10,5 +10,5 @@
 
 
-class sectionToExecute;
+//class sectionToExecute;
 class abstractElement;
 class dataManager;
@@ -60,12 +60,12 @@
    Return the vector of sectionToExecute of this
    */
-  inline std::vector <sectionToExecute*> getSectionsToExecute() { return sectionToExecute_;};
-  
+  //  inline std::vector <sectionToExecute*> getSectionsToExecute() { return sectionToExecute_;};
+  inline std::vector <abstractElement*>& getElements() { return elements_;};
   /**
    Add a sectionToExecute
    */
-  inline void addSectionToExecute(sectionToExecute* s) {
-    if (s) sectionToExecute_.push_back(s);
-  };
+  //  inline void addSectionToExecute(sectionToExecute* s) {
+  //    if (s) sectionToExecute_.push_back(s);
+  //  };
   
   /** Add an element after another one. Will put it in the same sectionToExecuteList. If the element after is NULL
@@ -85,9 +85,9 @@
  set the specific software for the given sectionToExecute number
  */
-  bool setSoftware(nomDeLogiciel, unsigned int sectionToExecuteNumber);
+  //  bool setSoftware(nomDeLogiciel, unsigned int sectionToExecuteNumber);
 
-  void clearSectionToExecute();
+  //  void clearSectionToExecute();
   /** Clear a specific jobList */
-  void clearSectionToExecute(int a);
+  //void clearSectionToExecute(int a);
 
   void removeElement(abstractElement* currentElement);
@@ -105,7 +105,17 @@
   }
   
+
+  bool isInside(abstractElement* previousElement);
+
 private:
 
-  std::vector <sectionToExecute*> sectionToExecute_;
+  bool insertAfter(abstractElement* previousElement,abstractElement* currentElement);
+
+
+
+
+  std::vector<abstractElement*>  elements_;
+  //  std::vector <sectionToExecute*> sectionToExecute_;
+
   particleBeam* currentBeam_;
 
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h	(revision 493)
@@ -18,5 +18,6 @@
   
   softwareGenerator();  
-  softwareGenerator(string inputFileName, sectionToExecute*, dataManager*);
+  //  softwareGenerator(string inputFileName, sectionToExecute*, dataManager*);
+  softwareGenerator(string inputFileName, computingBlock*, dataManager*);
 
   virtual ~softwareGenerator() {;}
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h	(revision 493)
@@ -17,5 +17,6 @@
   
   softwareMadx();
-  softwareMadx(string,sectionToExecute*,dataManager*);
+  //  softwareMadx(string,sectionToExecute*,dataManager*);
+  softwareMadx(string,computingBlock* ,dataManager*);
   virtual ~softwareMadx() {;}
 
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareParmela.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareParmela.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareParmela.h	(revision 493)
@@ -9,4 +9,6 @@
  protected : 
 
+     vector<int> relativeParmelaElementIndices_;
+
 
   bool beamFromParmela(string workingDir,unsigned numeroElement, double referencefrequency, vector<double>& centroid, bareParticle& refPart,vector<bareParticle>& particles );
@@ -14,4 +16,5 @@
   bool beamToParmela(string workingDir, particleBeam* partic );
 
+    void setRelativeParmelaElementIndices();
 
   string elementsData(const vector< pair<string, vector<string> > >& donnees) const ;
@@ -27,5 +30,6 @@
     softwareParmela();
     
-    softwareParmela(string inputFileName, sectionToExecute*, dataManager*);
+    //    softwareParmela(string inputFileName, sectionToExecute*, dataManager*);
+    softwareParmela(string inputFileName, computingBlock*, dataManager*);
 
   virtual ~softwareParmela() {;}
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTest.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTest.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTest.h	(revision 493)
@@ -18,5 +18,6 @@
     softwareTest();
     
-    softwareTest(string inputFileName, sectionToExecute*, dataManager*);
+    //    softwareTest(string inputFileName, sectionToExecute*, dataManager*);
+    softwareTest(string inputFileName, computingBlock*, dataManager*);
 
   virtual ~softwareTest() {;}
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTransport.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTransport.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareTransport.h	(revision 493)
@@ -20,5 +20,6 @@
  public : 
     softwareTransport();
-    softwareTransport(string inputFileName, sectionToExecute*, dataManager*);
+    //    softwareTransport(string inputFileName, sectionToExecute*, dataManager*);
+    softwareTransport(string inputFileName, computingBlock*, dataManager*);
 
   virtual ~softwareTransport() {;}
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUsersprogram.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUsersprogram.h	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUsersprogram.h	(revision 493)
@@ -13,5 +13,6 @@
  public : 
     softwareUsersprogram();
-    softwareUsersprogram(string inputFileName, sectionToExecute*, dataManager*);
+    //    softwareUsersprogram(string inputFileName, sectionToExecute*, dataManager*);
+    softwareUsersprogram(string inputFileName, computingBlock*, dataManager*);
 
   virtual ~softwareUsersprogram() {;}
Index: /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc	(revision 492)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc	(revision 493)
@@ -10,47 +10,23 @@
 }
 
-abstractSoftware::abstractSoftware(string inputFileName, sectionToExecute* sect, dataManager* data)
+// abstractSoftware::abstractSoftware(string inputFileName, sectionToExecute* sect, dataManager* data)
+// {
+//   inputFileName_ = inputFileName;
+//   //  sectionToExecute_ = sect;
+//   compBlock_ = NULL;
+//   dataManager_ = data;
+//   nameOfSoftware_ = new nomDeLogiciel("unknownSoftware");
+// }
+
+abstractSoftware::abstractSoftware(string inputFileName, computingBlock* cmpb, dataManager* data)
 {
   inputFileName_ = inputFileName;
-  sectionToExecute_ = sect;
+  compBlock_ = cmpb;
   dataManager_ = data;
+  cout << " abstractSoftware::abstractSoftware adresse manager " << dataManager_  << endl;
   nameOfSoftware_ = new nomDeLogiciel("unknownSoftware");
 }
 
 
-// void abstractSoftware::registerElement(nomdElements::typedElement nomdel,trivaluedBool b) 
-// {
-//   //  std::cout << " abstractSoftware::registerElement soft : " << nameOfSoftware_.getString() << std::endl;
-//   if (b == TBoolIgnore) {
-//     //    std::cout << " abstractSoftware::registerElement j'enregistre element " <<  nomdel << "   ignore " << std::endl;
-//     ignoredElements_.push_back(nomdel);
-//   } else if (b == TBoolOk) {
-//     //    std::cout << " abstractSoftware::registerElement j'enregistre element " <<  nomdel << "  OK " << std::endl;
-//     acceptedElements_.push_back(nomdel);
-//   }
-// }
-
-// trivaluedBool abstractSoftware::doAcceptElement(nomdElements::typedElement typdel) 
-// {
-
-//   //xx
-//   if (acceptedElements_.size() == 0 && nameOfSoftware_ != nomDeLogiciel::unknownSoftware) {
-//     return TBoolError;
-//   }
-
-//   if (std::find(acceptedElements_.begin(),acceptedElements_.end(),typdel) != acceptedElements_.end()) {
-//     return TBoolOk;
-//   }
-
-//   if (ignoredElements_.size() == 0) {
-//     return TBoolError;
-//   }
-
-//   if (std::find(ignoredElements_.begin(),ignoredElements_.end(),typdel) != ignoredElements_.end()) {
-//     return TBoolIgnore;
-//   }
-
-//   return TBoolOk;
-// }
 
 bool abstractSoftware::launchJob(string commandLine, string& resul)
Index: /Interface_Web/trunk/pspaWT/sources/controler/src/computingBlock.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/computingBlock.cc	(revision 493)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/computingBlock.cc	(revision 493)
@@ -0,0 +1,111 @@
+#include "computingBlock.h"
+#include "mixedTools.h"
+ #include "softwareUnknown.h"
+#include "expandedMachine.h"
+
+
+computingBlock::computingBlock(unsigned premier, unsigned nombre, abstractSoftware* s,expandedMachine* mch)  {
+  // dataManager_ = dtmg;
+  machine_ = mch;
+  if ( premier >= machine_->numberOfElements() ) {
+    rankOfFirstElement_ = 0;
+    numberOfelements_ = 0;
+  } else {
+    rankOfFirstElement_ = premier;
+    if ( nombre < machine_->numberOfElements() - rankOfFirstElement_ +1 ) {
+      numberOfelements_ = nombre;
+    } else numberOfelements_ = machine_->numberOfElements() - rankOfFirstElement_ +1;
+  }
+  if (s == NULL) {
+    software_ = new softwareUnknown();
+  } else {
+    software_ = s;
+  }
+}
+
+
+void computingBlock::FileAMLOutput(UAPNode* root)
+{
+  UAPNode* node = root->addChild("computingBlock");
+  node->addChild("software")->addAttribute("name",software_->getName());
+  unsigned noElem = rankOfFirstElement_;
+  UAPNode* blocNode = node->addChild("blocExtension");
+  blocNode->addAttribute("rankOfFirstElement",mixedTools::intToString(int(rankOfFirstElement_)));
+  blocNode->addAttribute("numberOfelements",mixedTools::intToString(int(numberOfelements_)));
+}
+
+
+void computingBlock::FileAMLInput( UAPNode* entree) {
+      string soft;
+      AMLtools::readAMLParameterAttribut(entree, "software", "name", soft);
+      software_ = machine_->getSoftwarePointer(soft, this);
+      int premier, nombre;
+      AMLtools::readAMLParameterAttribut(entree, "blocExtension", "rankOfFirstElement", premier);
+      AMLtools::readAMLParameterAttribut(entree, "blocExtension", "numberOfelements", nombre);
+      rankOfFirstElement_  = premier;
+      numberOfelements_ = nombre;
+      if ( !checkCompatibilityWithMachine() ) {
+	rankOfFirstElement_  = 0;
+	numberOfelements_ = 0;
+	cout << " computingBlock::FileAMLInput ERREUR lecture " << endl;
+      }
+}
+bool computingBlock::checkCompatibilityWithMachine() {
+  if ( !machine_ ) return false;
+  if ( rankOfFirstElement_ > machine_->numberOfElements() ) return false;
+  if ( numberOfelements_ > machine_->numberOfElements() - rankOfFirstElement_ + 1 ) return false;
+  return true;
+}
+bool computingBlock::checkCoherence(string& diagnosticErrors, string& diagnosticWarnings) {
+
+  cout << " computingBlock::checkCoherence() " << endl;
+  bool caMarche = true;
+
+  const nomDeLogiciel* prog = software_->getNomDeLogiciel();
+
+  for(unsigned k =0 ; k < numberOfelements_; k++)
+    {
+      abstractElement* elem = machine_->getElementPointer(rankOfFirstElement_ + k);
+      trivaluedBool tb = prog->doAcceptElement(elem->getNomdElement().getElementType());
+      cout << " GWt_softwarePanel::areDataCoherent() el " << elem->getLabel() << " tb= " << tb << endl;
+      if (tb  != TBoolOk ) {
+	if (tb == TBoolIgnore) {
+	  if(prog->getString() != "unknownSoftware") diagnosticWarnings += elem->getLabel() + " will be ignored by  "+ prog->getString() + "<br /> ";
+	  cout << " element " <<  elem->getLabel() << " ignore " << endl;
+	} else {
+	  diagnosticErrors += elem->getNomdElement().getExpandedName() + " is not allowed with " + prog->getString() + "<br /> ";
+	  cout << " element " <<  elem->getLabel() << " REFUSE " << endl;
+	  caMarche = false;
+	}
+      }
+    } //k
+  return caMarche;
+}
+
+
+//   vector< abstractElement* > computingBlock::getElements()  { 
+//     vector< abstractElement* > elems;
+//     for (unsigned k=0; k < numberOfelements_; k++ ) {
+//       elems.push_back( machine_->getElementPointer( rankOfFirstElement_ + k));
+//     }
+//     return elems;
+//   }
+
+abstractElement* computingBlock::getFirstElement() {
+  return machine_->getElementPointer( rankOfFirstElement_);
+}
+
+
+
+abstractElement*  computingBlock::getLastElement() {
+  cout << " computingBlock::getLastElement() premier " << machine_->getElementPointer( rankOfFirstElement_)->getLabel() << endl;
+  cout << "  nb elements : " << numberOfelements_ << endl;
+  cout << " computingBlock::getLastElement() dernier " << machine_->getElementPointer( rankOfFirstElement_ + numberOfelements_ - 1)->getLabel() << endl;
+  return machine_->getElementPointer( rankOfFirstElement_ + numberOfelements_ - 1);
+}
+
+
+ abstractElement* computingBlock::getElement(unsigned ind) { return machine_->getElementPointer( rankOfFirstElement_ + ind); }
+
+
+
